﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ShahyadS.TFSBuildInspectionModel;
using Microsoft.TeamFoundation.Build.Client;
using Microsoft.VisualStudio.TeamFoundation.Build;
using Microsoft.TeamFoundation.Common;
using Microsoft.VisualStudio.Shell;
using Microsoft.TeamFoundation.Client;
using Microsoft.TeamFoundation.Build.Controls.Extensibility;
using Microsoft.TeamFoundation.Controls;
using System.ComponentModel.Composition;
using Microsoft.TeamFoundation.VersionControl.Client;

namespace ShahyadS.VisualStudio
{
	[Export(typeof(IVisualStudioAdapter))]
	[ExportMetadata("Version", "11.0")]
	public class VS2012Adapter : IVisualStudioAdapter
	{
		TfsTeamProjectCollection TeamProjectCollection;
		IBuildServer BuildServer;
		VersionControlServer VersionControlServer;
		Uri _TeamProjectCollectionUrl;
		public Uri TeamProjectCollectionUrl
		{
			get
			{
				return _TeamProjectCollectionUrl;
			}
			set
			{
				_TeamProjectCollectionUrl = value;
				TeamProjectCollection = TfsTeamProjectCollectionFactory.GetTeamProjectCollection(_TeamProjectCollectionUrl);
				BuildServer = (IBuildServer)TeamProjectCollection.GetService(typeof(IBuildServer));
				VersionControlServer = TeamProjectCollection.GetService<VersionControlServer>();
			}
		}
		public void QueueNewBuild(Uri BuildDefinitionUri)
		{
			var buildDefinition = BuildServer.QueryBuildDefinitionsByUri(new Uri[] { BuildDefinitionUri }).FirstOrDefault();
			BuildServer.QueueBuild(buildDefinition);
		}
		public void OpenBuildExplorer(string teamProject, string buildDefinitionName)
		{
			IVsTeamFoundationBuild VsTfBuild = (IVsTeamFoundationBuild)ServiceProvider.GlobalProvider.GetService(typeof(IVsTeamFoundationBuild));
			VsTfBuild.BuildExplorer.CompletedView.Show(teamProject, buildDefinitionName, null, Microsoft.TeamFoundation.Build.Controls.DateFilter.Today);
		}
		public void FindInTeamExplorer(string teamProject, string buildDefinitionName)
		{
			ITeamFoundationContextManager teamFoundationContextManager = (ITeamFoundationContextManager)ServiceProvider.GlobalProvider.GetService(typeof(ITeamFoundationContextManager));
			var teamProjectUri = VersionControlServer.TryGetTeamProject(teamProject).ArtifactUri.ToString();
			teamFoundationContextManager.SetContext(TeamProjectCollection,teamProjectUri);
			ITeamExplorer teamExplorer = (ITeamExplorer)ServiceProvider.GlobalProvider.GetService(typeof(ITeamExplorer));
			teamExplorer.NavigateToPage(new Guid(TeamExplorerPageIds.Builds), null);
			IBuildsPageExt buildsPageExt = (IBuildsPageExt)teamExplorer.CurrentPage.GetExtensibilityService(typeof(IBuildsPageExt));
			//datarow.InvokeAction("Select");
		}
		public void EditBuildDefinition(Uri buildDefinitionUri)
		{
			IVsTeamFoundationBuild VsTfBuild = (IVsTeamFoundationBuild)ServiceProvider.GlobalProvider.GetService(typeof(IVsTeamFoundationBuild));
			VsTfBuild.DefinitionManager.OpenDefinition(buildDefinitionUri);
		}
		public void OpenBuildDetail(Uri buildUri)
		{
			IVsTeamFoundationBuild VsTfBuild = (IVsTeamFoundationBuild)ServiceProvider.GlobalProvider.GetService(typeof(IVsTeamFoundationBuild));
			VsTfBuild.DetailsManager.OpenBuild(buildUri);
		}
		public void ShowControllerManager()
		{
			IVsTeamFoundationBuild VsTfBuild = (IVsTeamFoundationBuild)ServiceProvider.GlobalProvider.GetService(typeof(IVsTeamFoundationBuild));
			VsTfBuild.ControllerManager.Show();
		}
	}
}
